package de.accso.flexinale.infrastructure.persistence;

import de.accso.flexinale.domain.model.Ticket;
import de.accso.flexinale.infrastructure.security.BenutzerEntity;
import de.accso.flexinale.shared_kernel.Identifiable;
import de.accso.flexinale.shared_kernel.Versionable;
import jakarta.persistence.EnumType;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;

@jakarta.persistence.Entity(name="Ticket")
public class TicketEntity implements Identifiable, Versionable, Serializable {
    @jakarta.persistence.Id
    public String id;  // primary key

    @jakarta.persistence.ManyToOne
    public FilmEntity film;

    @jakarta.persistence.ManyToOne
    public VorfuehrungEntity vorfuehrung;

    @jakarta.persistence.ManyToOne
    public BenutzerEntity benutzer;

    @jakarta.persistence.Enumerated(EnumType.STRING)
    public Ticket.VerkaufsKanal verkaufsKanal;

    @jakarta.persistence.Version
    private Integer version = 0;

    protected TicketEntity() {
    }

    public TicketEntity(final String id, final Integer version,
                        final FilmEntity film,
                        final VorfuehrungEntity vorfuehrung,
                        final BenutzerEntity benutzer,
                        final Ticket.VerkaufsKanal verkaufsKanal) {
        this.id = id;
        this.version = version;
        this.film = film;
        this.vorfuehrung = vorfuehrung;
        this.benutzer = benutzer;
        this.verkaufsKanal = verkaufsKanal;
    }

    @Override
    public Id id() {
        return Identifiable.Id.of(id);
    }

    @Override
    public Version version() {
        return Versionable.Version.of(version);
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        TicketEntity that = (TicketEntity) o;

        return new EqualsBuilder()
                .append(id, that.id).append(version, that.version)
                .append(film, that.film)
                .append(vorfuehrung, that.vorfuehrung).append(benutzer, that.benutzer)
                .append(verkaufsKanal, that.verkaufsKanal)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id).append(version)
                .append(film).append(vorfuehrung).append(benutzer)
                .append(verkaufsKanal)
                .toHashCode();
    }
}
